
/* INP.C */

#include "stdafx.h"

#include "MainForm.h"
#include "inp.h"
#include "out.h"

namespace Prekl {

char   ch;         /* zpracovavany znak */
int    InpPos;     /* pozice ve vstupnim textu */
int    InpColNum;  /* cislo sloupce */
int    InpLineNum; /* cislo radky */

static std::string InpTxt;     /* vstupmi text */
static std::string InpLine;    /* zpracovavana radka - jen pro ladeni */
static int         InpLen;     /* delka vstupniho textu */

/********************************* INPUT **********************************/

void OpenInp (void)
{
  InpTxt = getMainForm()->GetInpText (); /* text ze vstupniho okenka */
  InpLen = InpTxt.length ();
  InpPos = 0;

  InpColNum = 0;
  InpLineNum = 1;

  NextChar (); /* precti prvni znak */
}

/* ---------------------------------------------------------------------- */

void CloseInp (void)
{
  /* v nasem pripade nic */
}

/* ---------------------------------------------------------------------- */

void NextChar (void)
{
  if (InpPos < InpLen)
  {
     ch = InpTxt [InpPos]; /* precti jeden znak */
     InpPos ++;

     /* kopie vstupni radky - jen pro ladeni */
     if (InpColNum == 0)
        InpLine = getMainForm()->GetInpLine (InpLineNum);

     InpColNum ++; /* cislo sloupce */
     if (ch == LF)
     {
        InpLineNum ++; /* cislo radky */
        InpColNum = 0;
     }
  }

  else if (InpPos == InpLen)
  {
     ch = NUL; /* znak 0 - konec vstupniho textu */
     InpPos ++;
  }

  else
  {
     Error ("End of source"); /* konec vstupniho textu jiz byl ohlasen */
  }
}

/***************************** ERROR MESSAGES *****************************/

void Error (char * msg)
{
  getMainForm()->ShowError (msg);
}

} // end of namespace
